/*-
 * Copyright (C) @BABOLO  2004 Nov 18
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2004 Nov 18\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: cmd_file.c,v 1.26 2008/05/13 11:32:01 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <sysexits.h>
#include <dirent.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <errno.h>
#include <stdio.h>
#include <getCGIparm.h>
#include <mife.h>
#include <fts.h>
#include <err.h>
#include <babolo/BLINflag.h>
#include "pgoblin.h"
#include "pgob.h"

#define DBSET GLOBALDBSET

int
pgoblin_echo(pgoblin_exenv *exenv, pgoblin_r *r) {
    int ex = EX_OK;

    ifBLIN_QV4(exenv->options->flags)
        fprintf(stderr, "+pgoblin_echo %d %d %d\n", r[PGO_COUT].r, r[PGO_CCTL].r, r[PGO_CSTY].r);
    if  (r[PGO_CSTY].r) {
        if  (IO_CTL->flags & PGOBLIN_BINPARM) {
            ERROUT(EX_DATAERR, EINVAL);
        }
        /** IO_TEXT + **/
        ;;  IO_OUT->text = STYLESET->get(R_STYLE, IO_CTL->text);
        ;;  if  (IO_OUT->text) {
        ;;      IO_OUT->length = strlen(IO_OUT->text);
        ;;      IO_OUT->flags &= ~(PGOBLIN_FREETEXT | PGOBLIN_BINPARM);
        ;;      IO_OUT->flags |= PGOBLIN_TEXTPARM;
        ;;  } else {
        ;;      IO_OUT->length = 0;
        ;;      IO_OUT->flags &= ~(PGOBLIN_FREETEXT | PGOBLIN_BINPARM | PGOBLIN_TEXTPARM);
        /** IO_TEXT - **/
                ERROUT(EX_DATAERR, EINVAL);
            }
    } else if (r[PGO_COUT].r != r[PGO_CCTL].r) {
        if  (!(IO_CTL->flags & PGOBLIN_FREETEXT)) {
            /** IO_TEXT + **/
            ;;  IO_OUT->text = IO_CTL->text;
            ;;  IO_OUT->length = IO_CTL->length;
            ;;  IO_OUT->flags &= ~(PGOBLIN_FREETEXT | PGOBLIN_BINPARM);
            ;;  IO_OUT->flags |= PGOBLIN_TEXTPARM | (IO_CTL->flags & PGOBLIN_BINPARM);
            /** IO_TEXT - **/
        } else {
            /** IO_TEXT + **/
            ;;  if  (!(IO_OUT->text = malloc(IO_CTL->length + 1))) {
            ;;      ifBLIN_QV1(exenv->options->flags) warnx("No mem #echo");
            ;;      ERROUT(EX_OSERR, ENOMEM);
            ;;  } else {
            ;;      IO_OUT->length = IO_CTL->length;
            ;;      bcopy(IO_CTL->text, IO_OUT->text, IO_CTL->length);
            ;;      ((u_char*)IO_OUT->text)[IO_OUT->length] = '\0'
            ;;      IO_OUT->flags &= ~PGOBLIN_BINPARM;
            ;;      IO_OUT->flags |= PGOBLIN_TEXTPARM | PGOBLIN_FREETEXT;
            ;;  }
            /** IO_TEXT - **/
    }   }
out:
    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "-pgoblin_echo %d\n", ex);
    return(ex);
}

int
pgoblin_file(pgoblin_exenv *exenv, pgoblin_r *r) {
    int ex = EX_OK;

    ifBLIN_QV4(exenv->options->flags)
        fprintf(stderr, "+pgoblin_file %d %d %d\n", r[PGO_COUT].r, r[PGO_CCTL].r, r[PGO_CSTY].r);
    if  (r[PGO_CSTY].r) {
        if  (IO_CTL->flags & PGOBLIN_BINPARM) {
            ERROUT(EX_DATAERR, EINVAL);
        }
        /** IO_PATH + **/
        ;;  IO_OUT->path = STYLESET->get(R_STYLE, IO_CTL->text);
        ;;  if  (IO_OUT->path) {
        ;;      IO_OUT->flags &= ~PGOBLIN_FREEPATH;
        ;;      IO_OUT->flags |= PGOBLIN_FILEOVER | PGOBLIN_PATHPARM;
        ;;  } else {
        ;;      IO_OUT->flags &= ~(PGOBLIN_FREEPATH | PGOBLIN_FILEOVER | PGOBLIN_PATHPARM);
        /** IO_PATH - **/
                ERROUT(EX_DATAERR, EINVAL);
            }
    } else if (IO_CTL->flags & PGOBLIN_FREETEXT) {
        /** IO_PATH + **/
        ;;  if  (!(IO_OUT->path = strdup(IO_CTL->text))) {
        ;;      ifBLIN_QV1(exenv->options->flags) warnx("No mem #file");
        ;;      ERROUT(EX_OSERR, ENOMEM);
        ;;  } else {
        ;;      IO_OUT->flags |= PGOBLIN_FREEPATH | PGOBLIN_FILEOVER | PGOBLIN_PATHPARM;
        ;;  }
        /** IO_PATH - **/
    } else {
        /** IO_PATH + **/
        ;;  IO_OUT->path = IO_CTL->text;
        ;;  IO_OUT->flags &= ~PGOBLIN_FREEPATH;
        ;;  IO_OUT->flags |= PGOBLIN_FILEOVER | PGOBLIN_PATHPARM;
        /** IO_PATH - **/
    }
out:
    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "-pgoblin_file\n");
    return(ex);
}

int
pgoblin_cat(pgoblin_exenv *exenv, pgoblin_r *r) {
    int ex = EX_OK;

    ifBLIN_QV4(exenv->options->flags)
        fprintf(stderr, "+pgoblin_cat %d %d %d\n", r[PGO_COUT].r, r[PGO_CCTL].r, r[PGO_CSTY].r);
    if  (r[PGO_CSTY].r) {
        if  (IO_CTL->flags & PGOBLIN_BINPARM) {
            ERROUT(EX_DATAERR, EINVAL);
        }
        /** IO_PATH + **/
        ;;  IO_OUT->path = STYLESET->get(R_STYLE, IO_CTL->text);
        ;;  if  (IO_OUT->path) {
        ;;      IO_OUT->flags &= ~(PGOBLIN_FREEPATH | PGOBLIN_FILEOVER);
        ;;      IO_OUT->flags |= PGOBLIN_PATHPARM;
        ;;  } else {
        ;;      IO_OUT->flags &= ~(PGOBLIN_FREEPATH | PGOBLIN_FILEOVER | PGOBLIN_PATHPARM);
        /** IO_PATH - **/
                ERROUT(EX_DATAERR, EINVAL);
            }
    } else if (IO_CTL->flags & PGOBLIN_FREETEXT) {
        /** IO_PATH + **/
        ;;  if  (!(IO_OUT->path = strdup(IO_CTL->text))) {
        ;;      ifBLIN_QV1(exenv->options->flags) warnx("No mem #cat");
        ;;      ERROUT(EX_OSERR, ENOMEM);
        ;;  } else {
        ;;      IO_OUT->flags &= ~PGOBLIN_FILEOVER;
        ;;      IO_OUT->flags |= PGOBLIN_FREEPATH | PGOBLIN_PATHPARM;
        ;;  }
        /** IO_PATH - **/
    } else {
        /** IO_PATH + **/
        ;;  IO_OUT->path = IO_CTL->text;
        ;;  IO_OUT->flags &= ~(PGOBLIN_FREEPATH | PGOBLIN_FILEOVER);
        ;;  IO_OUT->flags |= PGOBLIN_PATHPARM;
        /** IO_PATH - **/
    }
out:
    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "-pgoblin_cat\n");
    return(ex);
}

int
pgoblin_getarg(pgoblin_exenv *exenv, pgoblin_r *r) {
    int ex = EX_OK;

    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "+pgoblin_getarg %d\n", r[PGO_COUT].r);
    if  ((ex = getCGIparmarray( 0, (u_char **)exenv->options->argv, "any", "\t", "\\N"
                              , IO_OUT->wri
                              , IO_OUT->onu
        ))                    ) {
        ifBLIN_QV1(exenv->options->flags) warn("getCGIparmarray");
    }
    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "-pgoblin_getarg %d\n", ex);
    return(ex);
}

int
pgoblin_getenv(pgoblin_exenv *exenv, pgoblin_r *r) {
    int ex = EX_OK;

    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "+pgoblin_getenv %d\n", r[PGO_COUT].r);
    if  ((ex = getCGIparmenv( gCGI_RNUM, (const u_char **)exenv->options->envp, "any", "\t", "\\N"
                            , IO_OUT->wri
                            , IO_OUT->onu
        ))                  ) {
        ifBLIN_QV1(exenv->options->flags) warn("getCGIparmenv");
    }
    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "-pgoblin_getenv %d\n", ex);
    return(ex);
}

int
pgoblin_getget(pgoblin_exenv *exenv, pgoblin_r *r) {
    int ex = EX_OK;

    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "+pgoblin_getget %d\n", r[PGO_COUT].r);
    if  ((ex = getCGIparmcopy( gCGI_RNUM|gCGI_SEPR, getenv("QUERY_STRING"), "any", "\t", "\\N"
                             , IO_OUT->wri
                             , IO_OUT->onu
        ))                   ) {
        ifBLIN_QV1(exenv->options->flags) warn("getget getCGIparmcopy");
    }
    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "-pgoblin_getget %d\n", ex);
    return(ex);
}

int
pgoblin_getpost(pgoblin_exenv *exenv, pgoblin_r *r) {
    int ex = EX_OK;

    ifBLIN_QV4(exenv->options->flags)
        fprintf(stderr, "+pgoblin_getpost %d in %s\n", r[PGO_COUT].r, IO_IN->mife ? "OK" : "NULL");
    if  (mife_read(IO_IN->mife, 0, IO_IN->offset) < 0) {
        ifBLIN_QV1(exenv->options->flags) warn("getpost 1");
        return(EX_OSERR);
    }
    if  ((ex = getCGIparmcopy( gCGI_RNUM | gCGI_SEPR
                             , mife_get(IO_IN->mife, IO_IN->offset)
                             , "any", "\t", "\\N"
                             , IO_OUT->wri
                             , IO_OUT->onu
        ))                   ) {
        ifBLIN_QV1(exenv->options->flags) warn("getpost getCGIparmcopy");
    }
    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "-pgoblin_getpost %d\n", ex);
    return(ex);
}

int
pgoblin_getproc(pgoblin_exenv *exenv, pgoblin_r *r) {
    int ex = EX_OK;

    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "+pgoblin_getproc %d\n", r[PGO_COUT].r);
    if  ((ex = getCGIparmproc( 0, "any", "\t", "\\N"
                             , IO_OUT->wri
                             , IO_OUT->onu
        ))                   ) {
        ifBLIN_QV1(exenv->options->flags) warn("getCGIparmproc");
    }
    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "-pgoblin_getproc %d\n", ex);
    return(ex);
}

int
pgoblin_getspq(pgoblin_exenv *exenv, pgoblin_r *r) {
    return(EX_UNAVAILABLE);
}

int
pgoblin_getstr(pgoblin_exenv *exenv, pgoblin_r *r) {
    int ex = EX_OK, l, j;
    FILE *fi;
    char *cont;
    ssize_t bl;
    size_t i;

    ifBLIN_QV4(exenv->options->flags)
        fprintf(stderr, "+pgoblin_getstr %d in %s\n", r[PGO_COUT].r, IO_IN->mife ? "OK" : "NULL");
    if  (!(fi = funopen( (void*)(IO_OUT->onu)
                       , NULL, (int (*)(void*, const char*, int))mife_writ, NULL, NULL
        ) )            ) {
        ifBLIN_QV1(exenv->options->flags) warn("funopen #0 on %d", r[PGO_COUT].r);
        ex = EX_OSERR;
    } else {
        for (j = 0, l = 1; !(IO_IN->mife->flag & MIFE_EOFL); IO_IN->offset += bl) {
            if  ((bl = mife_read(IO_IN->mife, 1 << (PGOBLIN_RAWIOBUFL + 16), IO_IN->offset)) < 0) {
                ifBLIN_QV1(exenv->options->flags) warn("getstr mife_read");
                ex = EX_IOERR;
                break;
            }
            if  (!(cont = mife_get(IO_IN->mife, IO_IN->offset))) {
                ifBLIN_QV1(exenv->options->flags) warn("getstr mife_get");
                ex = EX_IOERR;
                break;
            }
            for (i = 0; i < bl; i++, cont++) {
                switch (*cont) {
                    case '\\': if (l) fprintf(fi, "%d\t", j); l = 0; fprintf(fi, "\\\\");      break;
                    case '\0': if (l) fprintf(fi, "%d\t", j); l = 0; fprintf(fi, "\\0");       break;
                    case '\t': if (l) fprintf(fi, "%d\t", j); l = 0; fprintf(fi, "\\t");       break;
                    case '\n': if (l) fprintf(fi, "%d\t", j); l = 1; fprintf(fi, "\n"); j++;   break;
                    default:   if (l) fprintf(fi, "%d\t", j); l = 0; fprintf(fi, "%c", *cont); break;
        }   }   }
        if  (!l) fprintf(fi, "\n");
        fprintf(fi, "\\.\n");
    }
    if  (fclose(fi) < 0) {
        ifBLIN_QV1(exenv->options->flags) warn("fclose #0 on %d", r[PGO_COUT].r);
        ex = EX_OSERR;
    }
    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "-pgoblin_getstr %d\n", ex);
    return(ex);
}

int
pgoblin_getdir(pgoblin_exenv *exenv, pgoblin_r *r) {
    pgoblin_dir *dir;
    int ex = EX_OK;
    u_int32_t mode;
    u_char *q, *s;
    FILE *fi = NULL;

    ifBLIN_QV4(exenv->options->flags) fprintf( stderr, "+pgoblin_getdir %d %d %d =%s~\n"
                                             , r[PGO_COUT].r, r[PGO_CJOB].r, r[PGO_CCON].r
                                             , (char*)(IO_CTL->text)
                                             );
    if  (!(fi = funopen( (void*)(IO_OUT->onu)
                       , NULL, (int (*)(void*, const char*, int))mife_writ, NULL, NULL
        ) )            ) {
        ifBLIN_QV1(exenv->options->flags) warn("funopen #1 on %d", r[PGO_COUT].r);
        ex = EX_OSERR;
    } else {
        mode = strtoul(IO_CTL->text, (char**)&q, 0);
        if  (*q) q++;
        for (dir = NULL
            ; (dir = pgoblin.jobtable[R_JOB->flags & PGOBLIN_JOB_TYPE]->dir(exenv, dir, q))
            ;) {
            q = dir->ent;
            if  (getCGIparmpass3(0, "copy", &q)) {
                ifBLIN_QV1(exenv->options->flags) warnx("pgoblin_getdir: getCGIparmpass3");
                ex = EX_SOFTWARE;
                goto out;
            }
            s = "";
            if  (mode & 0x01) {
                fprintf(fi, "%d", dir->i);
                s = "\t";
            }
            if  (mode & 0x02) {
                fprintf(fi, "%s%s", s, q);
                s = "\t";
            }
            if  (mode & 0x04) {
                if  (dir->sb) fprintf(fi, "%s%lld", s, dir->sb->st_size); else fprintf(fi, "%s\\N", s);
                s = "\t";
            }
            if  (mode & 0x08) {
                if  (dir->sb) fprintf(fi, "%s%u", s, dir->sb->st_mode); else fprintf(fi, "%s\\N", s);
                s = "\t";
            }
            if  (mode & 0x10) {
                if  (dir->sb) fprintf(fi, "%s%u", s, dir->sb->st_uid); else fprintf(fi, "%s\\N", s);
                s = "\t";
            }
            if  (mode & 0x20) {
                if  (dir->sb) fprintf(fi, "%s%u", s, dir->sb->st_gid); else fprintf(fi, "%s\\N", s);
                s = "\t";
            }
            fprintf(fi, "\n");
            if  (q != dir->ent) free(q);
            q = NULL;
        }
        fprintf(fi, "\\.\n");
    }
out:
    if  (fi && fclose(fi) < 0) {
        ifBLIN_QV1(exenv->options->flags) warn("fclose #1 on %d", r[PGO_COUT].r);
        ex = EX_OSERR;
    }
    ifBLIN_QV4(exenv->options->flags) fprintf(stderr, "-pgoblin_getdir %d\n", ex);
    return(ex);
}
